#include "constexp.h"
#include <iostream>

constexpr unsigned int fibonacci(const unsigned int n) {
  if (n == 1 || n == 2) {
    return 1;
  }

  return fibonacci(n - 2) + fibonacci(n - 1);
}

void constexp::test() {
  std::cout << "Fibonacci(10): ";
  for (const unsigned int n : {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}) {
    std::cout << fibonacci(n) << " ";
  }
  std::cout << std::endl;

  int arr_1[fibonacci(10)];
  std::cout << "Array is " << sizeof(arr_1) / sizeof(int) << " items long"
            << std::endl;

  constexpr unsigned int arr_2_len = 10;
  int arr_2[arr_2_len];
  std::cout << "Array is " << sizeof(arr_2) / sizeof(int) << " items long"
            << std::endl;
}
